<?php

/***************************************************************************\
 *  SPIP, Systeme de publication pour l'internet                           *
 *                                                                         *
 *  Copyright (c) 2001-2005                                                *
 *  Arnaud Martin, Antoine Pitrou, Philippe Riviere, Emmanuel Saint-James  *
 *                                                                         *
 *  Ce programme est un logiciel libre distribue sous licence GNU/GPL.     *
 *  Pour plus de details voir le fichier COPYING.txt ou l'aide en ligne.   *
\***************************************************************************/


//
// Ce fichier ne sera execute qu'une fois
if (defined("_GISEH_INC_AUTH_CAS")) return;
define("_GISEH_INC_AUTH_CAS", "1");

class Auth_cas {
	var $nom, $login, $email, $statut;

	function init() {
		return true;
	}

//--------- Debut ajout CI (version CAS) -----
	
	// Verification de l'existence de l'identifiant dans la table des auteurs
	function ci_verifier_userid($ciuserid) {

		$return=false;
		
		// Interdire un email vide
		if ($ciuserid == '') { 
			$return=false;
		} else {
			// Eviter l'injection SQL
			$ciuserid=addslashes($ciuserid);

			if ($GLOBALS['ciconfig']['cicasuid']=="login") {
				$query = "SELECT * FROM spip_auteurs WHERE (login='".$ciuserid."') AND statut<>'5poubelle' ORDER BY nom";
			} else {
				$query = "SELECT * FROM spip_auteurs WHERE (email='".$ciuserid."' OR email='".addslashes(strtolower($ciuserid))."') AND statut<>'5poubelle' ORDER BY nom";
			}
			$result = spip_query($query);
			$cinumrows = spip_num_rows($result);
			if ($cinumrows==0) {
				$return=false;
			} else if ($cinumrows==1) {
				if ($row = spip_fetch_array($result)) {
					$this->nom = $row['nom'];
					$this->login = $row['login'];
					$this->email = $row['email'];
					$this->statut = $row['statut'];
					$return=true;
				}
			} else if ($cinumrows>1) {
				$ci_statut="";
				while ($row = spip_fetch_array($result)) {
					$cistocker=true;
					if ($ci_statut) {
						switch ($row['statut']) {
						case '0minirezo':
							if ($ci_statut=='0minirezo') {
								// le prcdent a-t-il l'option "creer des EC tout en restant admin du site" ?
								$cle='ecadminsite';
								$texte=$ci_pgp;
								$tagdebut="<".$cle.">";
								$posdebut = strpos($texte, $tagdebut);
								if ($posdebut === false){
									$value=false;
								} else {	 		
									$tagfin="</".$cle.">";
									$posdebut = $posdebut + strlen($cle) +2;
									$longval = strpos($texte, $tagfin)-$posdebut;
									$value=substr($texte,$posdebut,$longval);
								}
								if ($value=='ecadminsite'){
									// garder le prcdent si il a l'option "creer des EC tout en restant admin du site"
									$cistocker=false;
								} else {
									// garder le prcdent si le suivant est un admin restreint
									$cinewid=$row['id_auteur'];
									$cirestreint = spip_num_rows(spip_query("SELECT * FROM spip_auteurs_rubriques WHERE id_auteur=".$cinewid));
									if ($cirestreint > 0) $cistocker=false;						
								}
							}	
							break;
						case 'ciredval':
							if ($ci_statut=='0minirezo') $cistocker=false;
							break;
						case '1comite':
							if (ereg("^(0minirezo|ciredval)$",$ci_statut)) $cistocker=false;
							break;
						case '6forum':
							if (ereg("^(0minirezo|ciredval|1comite)$",$ci_statut)) $cistocker=false;
							break;
						}
					}
					
					if ($cistocker) {
						$ci_id_auteur = $row['id_auteur'];
						$ci_nom = $row['nom'];
						$ci_login = $row['login'];
						$ci_email = $row['email'];
						$ci_statut = $row['statut'];
						$ci_pgp = $row['pgp'];
					}
	
				}

				$this->nom = $ci_nom;
				$this->login = $ci_login;
				$this->email = $ci_email;
				$this->statut = $ci_statut;
				$return=true;
				
			}
		}
		
		if ($return==true){
			// Pour la solution hybride
			if (isset($_GET['sso'])){
				if ($_GET['sso']=="oui"){
					if(!isset($_COOKIE['equip_sso'])) {
						$ci_id_random = mt_rand(1,999999);
						if (!$ci_id_random) $ci_id_random = rand(1,999999);
						setcookie('equip_sso', $ci_id_random);
					}
				}
			}
		}
		
		return $return;
	}
	
	function activer() {
	}	
//--------- Fin ajout CI ---------------------


}

?>