<?php

// Ce fichier ne sera execute qu'une fois
if (defined("_GISEH_INC_CAS")) return;
define("_GISEH_INC_CAS", "1");

//--------- Debut ajout CI (version CAS) -----

// dtermination du HOST
function ci_url_host() {
	
	$ci_host = "";
	
	if(empty($_SERVER['HTTP_X_FORWARDED_SERVER'])){
		if (empty($_SERVER['SERVER_NAME'])) {
			$ci_host = $_SERVER['HTTP_HOST'];
		} else {
			$ci_host = $_SERVER['SERVER_NAME'];
		}
	} else {
		$ci_host = $_SERVER['HTTP_X_FORWARDED_SERVER'];
	}
	
	return $ci_host;
}

// dtermination de l'url de retour
function ci_url_retour($url) {
	
	$ci_url = "";
	
	// determination du HOST
	$ci_url = ci_url_host();

	// cas d'un site en HTTPS
    if ( isset($_SERVER['HTTPS']) && !empty($_SERVER['HTTPS']) && $_SERVER['HTTPS'] == 'on') {
		$ci_url = "https://".$ci_url;
    } else {
		$ci_url = "http://".$ci_url;
    }
	
	// cas particulier d'une adresse du type www.monserveur.com/repertoire_du_site/article.php3...
	if (isset($_SERVER['REQUEST_URI'])) {
		// le cas echeant, ne pas tenir compte du repertoire "ecrire"
		$ci_request_uri = str_replace("/ecrire/", "/", $_SERVER['REQUEST_URI']);
			
		$ci_pos = strrpos($ci_request_uri, "/");
		// ne pas tenir compte du premier "/" dans la recherche
		if ($ci_pos AND $ci_pos > 0) {
			$ci_url .= substr($ci_request_uri, 0, $ci_pos);
		}
	}
	
	// demande de redirection
	// (ne pas tenir compte du repertoire "ecrire" ni de "./")
	if ($url AND substr($url,0,6)!="ecrire" AND substr($url,0,1)!=".")
		$ci_url .= "/".$url;
	
	return $ci_url;
}

// Dterminer l'origine de l'appel (intranet, internet, ...)
// .i2 ou .ader.gouv.fr ou .gouv.fr ou .agri
// la valeur retourne est l'URL du serveur CAS correspondant  l'origine de l'appel
// la valeur par dfaut est l'URL du serveur CAS sur I-carr
function ci_url_serveur_cas() {

	$ciurlcas='';
	
	// Pour la solution hybride utilisation d'un cookie
	if ($GLOBALS['ciconfig']['cicas']=="oui" OR isset($_COOKIE['equip_sso'])) {

		$ci_host = ci_url_host();
		
		// adresse par defaut du serveur CAS
		$ciurlcas=$GLOBALS['ciconfig']['cicasurldefaut'];
		
		// autre adresse du serveur CAS	selon le type de terminaison de l'adresse d'appel du site SPIP
		if (isset($GLOBALS['ciconfig']['cicasurls'])) {
			if (is_array($GLOBALS['ciconfig']['cicasurls'])) {
				while (list($terminaison, $valcasurl) = each($GLOBALS['ciconfig']['cicasurls'])) {
					if (substr($ci_host,-strlen($terminaison))==$terminaison) {
						$ciurlcas=$valcasurl;
						break;
					}
				}
			}
		}
	}
	
	return $ciurlcas;
}	


function ci_lang_phpcas($lang="") {

	// dterminer le code de langue de phpCAS qui correspond au code de langue de SPIP
	// le paramtre d'entre est le code de langue de SPIP
	// la valeur retourne est le code de langue de phpCAS
	// la valeur par dfaut est 'french'
	
	$return='french';

	if ($lang) {
		switch ($lang) {
			case 'en':
				$return='english';
				break;
			case 'de':
				$return='german';
				break;
			case 'es':
				$return='spanish';
				break;
		}
	}

	return $return;
}	

//--------- Fin ajout CI ---------------------

?>