<?php

/***************************************************************************\
 *  SPIP, Systeme de publication pour l'internet                           *
 *                                                                         *
 *  Copyright (c) 2001-2008                                                *
 *  Arnaud Martin, Antoine Pitrou, Philippe Riviere, Emmanuel Saint-James  *
 *                                                                         *
 *  Ce programme est un logiciel libre distribue sous licence GNU/GPL.     *
 *  Pour plus de details voir le fichier COPYING.txt ou l'aide en ligne.   *
\***************************************************************************/

if (!defined("_ECRIRE_INC_VERSION")) return;


function giseh_action_editer_article_raccourci($array_droits,$connect_id_auteur,$connect_statut,$cilogin) {

	$return = true;

	$ci_id_article = _cireqsecure('id_article');
	$motscle = _cireqsecure('motscle');
	$ci_motscle_img_avant = _cireqsecure('cimodif_img_avant');
	
	
	if ($ci_id_article>0) {
		if (!$motscle) $motscle = array();
		$insertmotscle = array();
		$deletemotscle = array();
		$oldmotscle = array();
		
		if (isset($motscle['spip_recursions'])) unset($motscle['spip_recursions']); // subtilit de SPIP
		
		// mots cle de cet article mmoriss dans la base
		$result = cisql_select("lien.id_mot, mots.type", "spip_mots AS mots, spip_mots_articles AS lien", "lien.id_article=$ci_id_article AND lien.id_mot = mots.id_mot","","id_mot");
		while ($row = spip_fetch_array($result)) {
			// enlever les mots cls techniques
			if ($row['type']=="_affichage_article")
				$oldmotscle[] = $row['id_mot'];
		}
			
		// Prvention des accs concurents
		$ci_motscle_img_base = "";
		if ($oldmotscle) $ci_motscle_img_base = implode(",", $oldmotscle);
		$cimotscle_concurrent=false;
		if ($ci_motscle_img_avant) {
			if ($ci_motscle_img_base) {
				if (!($ci_motscle_img_avant==$ci_motscle_img_base)) $cimotscle_concurrent=true;
			} else {
				$cimotscle_concurrent=true;
			}		
		} elseif ($ci_motscle_img_base) $cimotscle_concurrent=true;
	
		if (!$cimotscle_concurrent) {
	
			foreach ($motscle as $motcle) {
				$motcle = intval($motcle);
				if (in_array($motcle,$oldmotscle)){
					// si le nouveau motcle est le mme que celui en base, ne rien faire
				} elseif ($motcle>0) {
					$insertmotscle[] = $motcle;
				}		
			}
			
			reset($oldmotscle);
			reset($motscle);
			foreach ($oldmotscle as $oldmotcle) {
				$oldmotcle = intval($oldmotcle);
				if (in_array($oldmotcle,$motscle)){
					// si l'ancien mot est toujours l, ne rien faire
				} else {
					$deletemotscle[] = $oldmotcle;
				}		
			}
			
			if ($insertmotscle) {
				foreach ($insertmotscle as $insertmotcle) {
					cisql_insertq('spip_mots_articles', array('id_mot' => $insertmotcle, 'id_article' => $ci_id_article));
				}	
			}
			
			if ($deletemotscle) {
				foreach ($deletemotscle as $deletemotcle) {
					cisql_delete("spip_mots_articles", "id_mot=$deletemotcle AND id_article=$ci_id_article");
				}	
			}
			
		}			
	}

	return $return;
}
?>