<?php

if (!defined("_ECRIRE_INC_VERSION")) return;


// Ce fichier ne sera execute qu'une fois
if (defined("_ECRIRE_GISEH_SECURITE")) return;
define("_ECRIRE_GISEH_SECURITE", "1");


include_ecrire('giseh_commun/abstract_sql.php');	// nouveau


//--------- Debut ajout CI (securite) -----

// Renvoie le _GET ou le _POST emis par l'utilisateur
// et le nettoie au passage
function _cireqsecure($var) {

	$return = NULL;	
	$a="";
	if (isset($_GET[$var])) $a = $_GET[$var];
	elseif (isset($_POST[$var])) $a = $_POST[$var];
	
	if ($a) {
		
		// cas des id_...
		if (strlen($var)>3 AND substr($var,0,3)=="id_") {
			return intval($a);
		}
				
		// cas d'autres valeurs entires
		$array_var_entieres = array("ciposition","doc_supp","largeur_document","hauteur_document");
		if (in_array($var, $array_var_entieres)) {
			return intval($a); 			
		}

		// cas des oui / non
		$array_var_ouinon = array("email_unique","site_obli","site_unique","message","ajout_logo","forcer_document","ajout_doc","remplacer_doc");
		if (in_array($var, $array_var_ouinon)) {
			if ($a=="oui" OR $a=="non") {
				return $a;	
			} else {
				$return = "";
			}
		}
		
		// cas des md5
		$array_md5 = array("md5_article","hash","hash_id_auteur");
		if (in_array($var, $array_md5)) {
			if(ereg("^[a-f0-9]{32}$",$a)) $return = $a;
		}

		
		switch ($var) {
		case "cipage":
			$array_page=array("article","articles_non_publies","document","image","vignette","multipj","referpj","logo","raccourci","motcle","redirection","auteur","forme","forum","petition","datepublication","calendrier","rubart","revision","envoimembre","statistique","doc_remplacer","doc_modifier","doc_supprimer");
			if (in_array($a,$array_page)) {
				$return = "_template/__giseh_".$a;
			} else {
				$return = "";
			}
			break;
		case "ciaction":
			$array_action = array("editer_article","editer_document","ajouter_article","ajouter_document","supprimer_document","editer_article_motcle","editer_article_forme","editer_article_raccourci","editer_article_redirection","editer_article_auteur","editer_article_petition","editer_article_forum","editer_article_calendrier","editer_article_datepublication","editer_article_rubart");
			if (in_array($a,$array_action)) {
				$return = $a;
			} else {
				$return = "";
			}
			break;
		case "ins_document":
			$array_insdoc = array("descriptif","texte");
			if (in_array($a,$array_insdoc)) {
				$return = $a;
			} else {
				$return = "";
			}
			break;
		case "ins_image":
			$array_insimg = array("descriptif","texte");
			if (in_array($a,$array_insimg)) {
				$return = $a;
			} else {
				$return = "";
			}
			break;
		case "align_image":
			$array_alignimg = array("left","center","right","vignette");
			if (in_array($a,$array_alignimg)) {
				$return = $a;
			} else {
				$return = "";
			}
			break;
		case "motscle":
			if (is_array($a)) {
				$return = $a;
			} else {
				$return = "";
			}
			break;
		case "auteurs":
			if (is_array($a)) {
				$return = $a;
			} else {
				$return = "";
			}
			break;
		case "cimodif_img_avant":
			if($a) {
				$return = $a;	// sert uniquement en comparaison
			} else {
				$return = "";
			}
			break;
		case "virtuel":			
			if($a) {
				$return = $a;	// SPIP ne protge pas le virtuel
			} else {
				$return = "";
			}
			break;
		case "mode":
			/* $mode :
			'image' => image en mode image
			'vignette' => personnalisee liee a un document
			'document' => doc ou image en mode document
			'distant' => lien internet
			'changer_virtuel' => article redirection
			'changer_forum'
			'changer_petition'
			*/		
			$array_mode = array("document","image","vignette","distant","changer_virtuel","changer_forum","changer_petition");
			if (in_array($a, $array_mode)) {
				return $a; 			
			} else {
				$return = "";
			}
			break;
		case "image_supp":
			if($a) {
				$return = $a;	// protg dans spip_image.php3
			} else {
				$return = "";
			}
			break;
		case "type":
			$array_type = array("article");
			if (in_array($a, $array_type)) {
				return $a; 			
			} else {
				$return = "";
			}
			break;
		case "logo":
			if (strlen($a)>5) {
				if((substr($a,0,5)=="arton" AND intval(substr($a,5))>0) OR (substr($a,0,6)=="artoff" AND intval(substr($a,6))>0)) {
					$return = $a;
				}
			}
			break;
		case "change_accepter_forum":
			$array_modforum = array('pos', 'pri', 'abo', 'non');
			if(in_array($a,$array_modforum)) {
				$return = $a;
			} else {
				$return = "";
			}
			break;
		case "datepublication":
		   	if (isset($a) AND $a!="") {
			    list($dd,$mm,$yy)=explode("/",$a);
			    if ($dd!="" && $mm!="" && $yy!="") {
				    if (is_numeric($yy) && is_numeric($mm) && is_numeric($dd)) {
				            if (checkdate($mm,$dd,$yy))
								$return = $a;
				    }
			    } 
		   	} 
			break;
		case "heurepublication":
		   	if (isset($a) AND $a!="") {
			    list($hh,$mm)=explode(":",$a);
			    if ($hh!="" && $mm!="") {
				    if (intval($hh)<24 && intval($mm)<61) {
						$return = $a;
				    }
			    } 
		   	} 
			break;
		case "dateredaction":
		   	if (isset($a) AND $a!="") {
			    list($dd,$mm,$yy)=explode("/",$a);
			    if ($dd!="" && $mm!="" && $yy!="") {
				    if (is_numeric($yy) && is_numeric($mm) && is_numeric($dd)) {
				            if (checkdate($mm,$dd,$yy))
								$return = $a;
				    }
			    } 
		   	} 
			break;
		case "supprimer":
			if ($a=="supprimer")
				$return = $a;
			break;
/*			
		case "jour":
			if (intval($a)>0 AND intval($a)<32)
				$return = intval($a);
			break;
		case "mois":
			if (intval($a)>0 AND intval($a)<13)
				$return = intval($a);
			break;
		case "annee":
			if (intval($a)>1900 AND intval($a)<3000)
				$return = intval($a);
			break;
*/			
		case "heure":
			if (intval($a)>0 AND intval($a)<25)
				$return = intval($a);
			break;
		case "minute":
			if (intval($a)>0 AND intval($a)<61)
				$return = intval($a);
			break;
		case "change_petition":
			if ($a=="on" OR $a=="off")
				return $a;
			break;
		case "texte_petition":
			$return = ci_secure_titre($a);
			break;
		case "titre":
			// vite ceux qui mettent <img... dans le titre
			$return = ci_secure_titre($a);
			break;
		case "descriptif":
			return $a;	// SPIP ne protge pas le descriptif lorsque l'auteur est authentifi
			break;
		case "texte":
			// si on utilise safehtml sur le texte, cela provoque des effets de bord.
			// aussi, alignement sur le niveau de scurit de SPIP
			return $a;	// SPIP ne protge pas le texte si l'auteur est authentifi
			break;
		case "statut_nouv":
			$array_statut_article = array("prepa","prop","publie","poubelle","refuse","Demander la publication de cet article","Publier");
			if (in_array($a,$array_statut_article)) $return = $a;
			if ($a=="Demander la publication de cet article") $return = "prop";
			if ($a=="Publier") {
				$_POST['voirenligne']='oui';
				$return = "publie";
			}
			break;
		default:
			break;
		}
		
		
	}
	
	return $return;
}



//-------------------------------------------------------
// Determiner les droits d'edition de l'article
function ci_droit_article($connect_statut, $ci_id_article=0, $ci_id_rubrique=0) {

	global $connect_id_auteur;

	$flag_auteur=false;
	$flag_editable=false;
	$ciflag_lecture=false;
	$cipeutpublier=false;
	$cistatut_article="";
	$rubrique_article=0;
	$return = array();
	
	
	if ($ci_id_article>0) {
		// modification d'un article
		
		if ($row = cisql_fetsel("statut, titre, id_rubrique", "spip_articles", "id_article=$ci_id_article")) {
			$cistatut_article = $row['statut'];
			$rubrique_article = $row['id_rubrique'];
			if (!$ci_id_rubrique) $ci_id_rubrique=$rubrique_article;
			$_GET['id_rubrique']=$ci_id_rubrique;
		} else {
			$cistatut_article = '';
			$rubrique_article = 0;
		}
		$connect_statut = ci_connect_statut($rubrique_article);
		
		$result_auteur = cisql_select("id_auteur", "spip_auteurs_articles", "id_article=$ci_id_article AND id_auteur=$connect_id_auteur");
		
		$flag_auteur = (cisql_count($result_auteur) > 0);
		$flag_editable = ((acces_rubrique($rubrique_article) AND $connect_statut == '0minirezo')
			OR ($flag_auteur AND ($cistatut_article == 'prepa' OR $cistatut_article == 'prop' OR $cistatut_article == 'poubelle')));
		$flag_editable = ($flag_editable OR (ci_connect_ciredval($rubrique_article) AND $flag_auteur));
		
		$ciflag_lecture = (ci_lecture_rubrique($rubrique_article)
			OR ($flag_auteur AND ($cistatut_article == 'prepa' OR $cistatut_article == 'prop' OR $cistatut_article == 'poubelle')));
		$ciflag_lecture = ($ciflag_lecture OR (ci_connect_ciredval($rubrique_article) AND $flag_auteur));
		if ($ciflag_lecture) {
			$_GET['id_rubrique']=$rubrique_article;
		}
		
		if (($connect_statut == '0minirezo' AND acces_rubrique($ci_id_rubrique)) OR (ci_connect_ciredval($ci_id_rubrique) AND $flag_auteur)) {
			$cipeutpublier=true;
		}
		
	} elseif ($ci_id_rubrique>0) {
		// cration d'un article
		
		$ciflag_lecture = ci_lecture_rubrique($ci_id_rubrique);

		$connect_statut = ci_connect_statut($ci_id_rubrique);
		
		if (($connect_statut == '0minirezo' AND acces_rubrique($ci_id_rubrique)) OR ci_connect_ciredval($ci_id_rubrique)) {
			$cipeutpublier=true;
		}
	
	}
	
	$return['auteur'] = $flag_auteur;
	$return['editable'] = $flag_editable;
	$return['lecture'] = $ciflag_lecture;
	$return['publier'] = $cipeutpublier;
	$return['statut_article'] = $cistatut_article;
	$return['rubrique_article'] = $rubrique_article;
	
	return $return;
	
}

//---------- Fin ajout CI -----------------

?>