<?php

/***************************************************************************\
 *  SPIP, Systeme de publication pour l'internet                           *
 *                                                                         *
 *  Copyright (c) 2001-2005                                                *
 *  Arnaud Martin, Antoine Pitrou, Philippe Riviere, Emmanuel Saint-James  *
 *                                                                         *
 *  Ce programme est un logiciel libre distribue sous licence GNU/GPL.     *
 *  Pour plus de details voir le fichier COPYING.txt ou l'aide en ligne.   *
\***************************************************************************/


// Ce fichier ne sera execute qu'une fois
if (defined("_INC_PUBLIC_GLOBAL")) return;
define("_INC_PUBLIC_GLOBAL", "1");

// fonction principale declenchant tout le service
function calcule_header_et_page ($fond, $delais) {
	  global $affiche_boutons_admin, $auteur_session, $flag_dynamique,
	  $flag_ob, $flag_preserver, $forcer_lang, $ignore_auth_http,
	  $lastmodified, $recherche, $use_cache, $var_confirm, $var_mode,
	  $var_recherche, $tableau_des_erreurs;
	  global $_GET, $_POST;
//--------- Debut ajout CI ( modification du comptage des statistiques en raison du proxy du service et reverse proxy du centre serveur) --------------------------------
	  global $ciidstatvisiteur;
	  $ciidstatvisiteur = "";
//--------- Fin ajout CI ---------------------
//--------- Debut ajout CI (acces restreints)(ec) -----
	  global $delais;
	  global $ciliste_rubriques,$ciliste_rubdusite,$ciliste_rubprepa;
		$ciliste_rubriques = "";
		$ciliste_rubdusite = "";  
		$ciliste_rubprepa = "";	  
//--------- Fin ajout CI ---------------------

	// Regler le $delais par defaut
	if (!isset($delais))
		$delais = 1 * 3600;
	if ($recherche)
		$delais = 0;
		
	// authentification du visiteur
	if ($GLOBALS['_COOKIE']['spip_session'] OR
	($GLOBALS['_SERVER']['PHP_AUTH_USER']  AND !$ignore_auth_http)) {
		include_ecrire ("inc_session.php3");
//--------- Debut ajout CI (acces restreints)(ec) ---------------------
//		verifier_visiteur();
		if (verifier_visiteur()) {
			if (cilire_config('ciautorisear')=="oui"){
					// ne pas stocker dans le cache
					$delais = 0;
			}
		}			
//--------- Fin ajout CI ---------------------
//--------- Debut ajout CI (host auth site public) -----
		else {
			if (ci_host_auth_site_public($fond) OR ci_ip_auth_site_public($fond)) {
				$link = new Link();
				redirige_par_entete('spip_login.php3?url='.urlencode($link->getUrl()));
			}
		}
	} else {
		if (ci_host_auth_site_public($fond) OR ci_ip_auth_site_public($fond)) {
			$link = new Link();
			redirige_par_entete('spip_login.php3?url='.urlencode($link->getUrl()));
		}
//--------- Fin ajout CI ---------------------
	}
	// multilinguisme
	if ($forcer_lang AND ($forcer_lang!=='non') AND !count($_POST)) {
		include_ecrire('inc_lang.php3');
		verifier_lang_url();
	}
	if ($_GET['lang']) {
		include_ecrire('inc_lang.php3');
		lang_select($_GET['lang']);
	}

	// Si envoi pour un forum, enregistrer puis rediriger

	if (strlen($_POST['confirmer_forum']) > 0
	OR ($GLOBALS['afficher_texte']=='non' AND $_POST['ajouter_mot'])) {
		include('inc-messforum.php3');
		redirige_par_entete(enregistre_forum());
	}

	// si signature de petition, l'enregistrer avant d'afficher la page
	// afin que celle-ci contienne la signature

	if ($_GET['var_confirm']) {
		include_local(find_in_path('inc-formulaire_signature.php3'));
		reponse_confirmation($_GET['id_article'], $var_confirm);
	}

	//  refus du debug si pas dans les options generales ni admin connecte
	if ($var_mode=='debug') {
		if (($GLOBALS['code_activation_debug'] == 'oui')
		OR $auteur_session['statut'] == '0minirezo')
			spip_log('debug !');
		else {
			$link = new Link();
			$link->addvar('var_mode', 'debug');
			redirige_par_entete('spip_login.php3?url='
				.urlencode($link->getUrl()));
			exit;
		}
	}

	// est-on admin ?
	if ($affiche_boutons_admin = (
//--------- Debut ajout CI (3clics) -----
//	(!$flag_preserver AND $GLOBALS['_COOKIE']['spip_admin'])
	(!$flag_preserver AND $GLOBALS['_COOKIE']['spip_session'] AND $GLOBALS['auteur_session']['statut']!='6forum')
//--------- Fin ajout CI ----------------
	OR $var_mode == 'debug'))
		include_local(find_in_path('inc-formulaire_admin.php3'));

	$tableau_des_erreurs = array();
	$page = afficher_page_globale ($fond, $delais, $use_cache);

	
//--------- Debut ajout CI ( modification du comptage des statistiques en raison du proxy du service et reverse proxy du centre serveur) --------------------------------
	if (lire_meta("activer_statistiques") != "non") {
		if(!isset($_COOKIE['equip_stat'])) {
			$ciidstatvisiteur = mt_rand(1,999999);
			if (!$ciidstatvisiteur) $ciidstatvisiteur = rand(1,999999);
			setcookie('equip_stat', $ciidstatvisiteur, time()+157680000);  // expire dans 5 ans
		}
	}
//--------- Fin ajout CI ---------------------
	
	//
	// Envoyer les entetes appropries
	// a condition d'etre sur de pouvoir le faire
	//
	if (!headers_sent() AND !$flag_preserver) {

		// Content-type: par defaut html+charset (poss surcharge par la suite)
		header("Content-Type: text/html; charset=".lire_meta('charset'));

		if ($flag_ob) {
			// Si la page est vide, gerer l'erreur 404
			if (trim($page['texte']) === ''
			AND $var_mode != 'debug') {
				http_status(404);
				$contexte_inclus = array(
					'erreur_aucun' => message_erreur_404()
				);
				$page = array('texte' => '<'.'?php
					$contexte_inclus = array();
					include(\''.addslashes(find_in_path('404.php3')).'\');
					?'.'>',
				'process_ins' => 'php');
			}
//--------- Debut ajout CI (acces restreints, previsualisation, multisites) ---------------------
/*
			// Interdire au client de cacher un login, un admin ou un recalcul
			else if ($flag_dynamique OR $var_mode
			OR $GLOBALS['_COOKIE']['spip_admin']) {
				header("Cache-Control: no-cache,must-revalidate");
				header("Pragma: no-cache");
			}
			// Pour les autres donner l'heure de modif
			else if ($lastmodified) {
				header("Last-Modified: ".http_gmoddate($lastmodified)." GMT");
			}	
*/
			else {
				$ciheader = false;
				
				// Pour les sites sans ar autoris et si l'on n'est pas authentifi, etc.
				if (!$flag_dynamique && !$var_mode && !$GLOBALS['_COOKIE']['spip_admin']) {
				 	 if ($lastmodified) {
						if (!$auteur_session) {
							if (cilire_config('ciautorisear')!="oui") {
								$ciheader = true;
							}
							 // Pour le comarquage afin d'viter le problme de IE6 + compression http + header de non mise en cache
							if ($fond == '_template/__texte_article') {
								$ciheader = true;
							}
						}
				 	 }
				 }
				if ($ciheader) {
					// Expiration de la page dans 1 heure ou moins si le dlai de mise en cache de SPIP est infrieur
					@header("Last-Modified: ".http_gmoddate($lastmodified)." GMT");
					@Header ("Expires: ".gmdate("D, d M Y H:i:s", $lastmodified + $delais)." GMT");
				 } else {
					@Header("Expires: 0");
					@Header("Cache-Control: no-cache,no-store");
					@Header("Pragma: no-cache");
				 }
			}
//--------- Fin ajout CI ---------------------
		}
	}

	return $page;
}


//
// Aller chercher la page dans le cache ou pas
//
function obtenir_page ($contexte, $chemin_cache, $delais, &$use_cache, $fond, $inclusion=false) {
	global $lastmodified;

//--------- Debut ajout CI (acces restreints)(ec) -----
	global $auteur_session,$ciliste_rubriques;
	if ($use_cache) {
		if ($auteur_session) {
			include_local('inc-calcul.php3');
			// page globale ? calculer le contexte
			if (!$contexte OR !$ciliste_rubriques)
				$contexte = calculer_contexte();
		}
	}	
//--------- Fin ajout CI ---------------------
	
	
	if (!$use_cache) {
	
		include_local('inc-calcul.php3');

		// page globale ? calculer le contexte
//--------- Debut ajout CI (acces restreints)(ec) -----
//		if (!$contexte)
		if (!$contexte OR !$ciliste_rubriques)
//--------- Fin ajout CI ---------------------
			$contexte = calculer_contexte();

		spip_timer('calculer_page');
		$page = calculer_page($chemin_cache,
			array('fond' => $fond,
				'contexte' => $contexte),
			$delais,
			$inclusion);

		$lastmodified = time();

		// log
		if (!$log = $chemin_cache) $log = "($fond, delais=$delais, "
		. $GLOBALS['_SERVER']['REQUEST_METHOD'].")";
//		spip_log (($inclusion ? 'calcul inclus':'calcul').' ('
//		.spip_timer('calculer_page')."): $log");

		// Nouveau cache : creer un invalideur 't' fixant la date
		// d'expiration et la taille du fichier
		if (@file_exists($chemin_cache)) {
			// Ici on ajoute 3600s pour eviter toute concurrence
			// entre un invalideur et un appel public de page
			$bedtime = time() + $delais + 3600;
			$taille = @filesize($chemin_cache);
			$fichier = addslashes($chemin_cache);
			spip_query("INSERT IGNORE INTO spip_caches (fichier,id,type,taille)
			VALUES ('$fichier','$bedtime','t','$taille')");
		}

	} else {

		//
		// Lire le fichier cache
		//
		lire_fichier ($chemin_cache, $page['texte']);
		$lastmodified = max($lastmodified, @filemtime($chemin_cache));
		# spip_log ("cache $chemin_cache $lastmodified");

		//
		// Lire sa carte d'identite & fixer le contexte global
		//
		if (preg_match("/^<!-- ([^\n]*) -->\n(.*)/ms", $page['texte'], $match)
		AND is_array($meta_donnees = unserialize($match[1]))) {
			foreach ($meta_donnees as $var=>$val)
				$page[$var] = $val;

			$page['texte'] = $match[2];

			// Remplir les globals pour les boutons d'admin
			if (!$inclusion AND is_array($page['contexte']))
				foreach ($page['contexte'] as $var=>$val)
					$GLOBALS[$var] = $val;
		}

	}

	return $page;
}


//
// Appeler cette fonction pour obtenir la page principale
//
function afficher_page_globale ($fond, $delais, &$use_cache) {
	global $flag_preserver, $flag_dynamique, $lastmodified;
	global $var_preview, $var_mode, $delais;
	include_local ("inc-cache.php3");

	// demande de previsualisation ?
	// -> inc-calcul.php3 n'enregistrera pas les fichiers caches
	// -> inc-reqsql-squel.php3 acceptera les objets non 'publie'
	if ($var_mode == 'preview') {
		// Verifier qu'on a le droit de previsualisation
		$statut = $GLOBALS['auteur_session']['statut'];
//--------- Debut ajout CI (previsualisation) -----
//		if ($statut=='0minirezo' OR
//		(lire_meta('preview')=='1comite' AND $statut=='1comite')) {
//			$var_mode = 'recalcul';
		if ($statut=='0minirezo' OR $statut=='1comite') {
			$var_mode = 'calcul';
//--------- Fin ajout CI ---------------------
			$delais = 0;
			$var_preview = true;
			spip_log('preview !');
		} else
			$var_preview = false;
	}

//--------- Debut ajout CI (acces restreints)(ec) -----
	$ci_use_cache=ci_use_cache();
	if (!$ci_use_cache) {
		$use_cache=false;
		$delais = 0;
		$chemin_cache = '';
	} else {
//--------- Fin ajout CI ---------------------
	
		// Calculer le chemin putatif du cache
		if ($delais > 0)
			$chemin_cache = generer_nom_fichier_cache('', $fond);
		else
			$chemin_cache = '';
	
		// Faut-il effacer des pages invalidees ?
		if (lire_meta('invalider')) {
			include_ecrire('inc_connect.php3');
			include_ecrire('inc_meta.php3');
			lire_metas();
			if (lire_meta('invalider') AND $GLOBALS['db_ok'])
				retire_caches($chemin_cache);
		}

//--------- Debut ajout CI (acces restreints)(ec) -----
	}
//--------- Fin ajout CI ---------------------

//--------- Debut ajout CI -----
	// en cas de calcul, purge du cache de second niveau  y compris pour les sites internet
	if ($var_mode=='calcul' AND $GLOBALS['auteur_session']) {
		ci_purger_second_cache('CACHE', -1);
	}
//--------- Fin ajout CI -------


	// Peut-on utiliser un fichier cache ?
//--------- Debut ajout CI (acces restreints)(ec) -----
//	determiner_cache($delais, $use_cache, $chemin_cache);
	if ($ci_use_cache) determiner_cache($delais, $use_cache, $chemin_cache);
//--------- Fin ajout CI ---------------------

	// Repondre gentiment aux requetes sympas
	// (ici on ne tient pas compte d'une obsolence du cache ou des
	// eventuels fichiers inclus modifies depuis la date
	// HTTP_IF_MODIFIED_SINCE du client)
	if ($GLOBALS['HTTP_IF_MODIFIED_SINCE'] AND !$var_mode
	AND $chemin_cache AND !$flag_dynamique) {
		$lastmodified = @filemtime($chemin_cache);
		$headers_only = http_last_modified($lastmodified);
	}
	$headers_only |= ($GLOBALS['_SERVER']['REQUEST_METHOD'] == 'HEAD');

	if ($headers_only) {
		if ($chemin_cache)
			$t = @filemtime($chemin_cache);
		else
			$t = time();
		@header('Last-Modified: '.http_gmoddate($t).' GMT');
		@header('Connection: close');
		// Pas de bouton admin pour un HEAD
		$flag_preserver = true;
	}
	else {
		// Obtenir la page
		$page = obtenir_page ('', $chemin_cache, $delais, $use_cache,
		$fond, false);
	}

	if ($chemin_cache) $page['cache'] = $chemin_cache;

	if ($var_preview AND !$flag_preserver) {
//--------- Debut ajout CI (previsualisation) -----
		$ciurl = ci_url_retour();
//--------- Fin ajout CI ---------------------
		include_ecrire('inc_lang.php3');
		include_ecrire('inc_filtres.php3');
		lang_select($GLOBALS['auteur_session']['lang']);
		$x = majuscules(_T('previsualisation'));
		$page['texte'] .= '<div style="
		display: block;
		color: #eeeeee;
		background-color: #111111;
		padding-right: 5px;
		padding-top: 2px;
		padding-bottom: 5px;
		font-size: 20px;
		top: 0px;
		left: 0px;
		position: absolute;
		z-index:100;
		">'; 
//--------- Debut ajout CI (previsualisation) -----
//		z-index:100; //ajout ci-dessus
//		">' // ci-dessus
//		  . http_img_pack('naviguer-site.png', $x, '')
//		  ."&nbsp;$x</div>";
		if ($ciurl){
			$page['texte'] .= '<a href="'.$ciurl.'">'.http_img_pack('naviguer-site.png', $x, '').'</a>';
		} else {
			$page['texte'] .= http_img_pack('naviguer-site.png', $x, '');
		}
		$page['texte'] .="&nbsp;$x</div>";	
//--------- Fin ajout CI ---------------------		
	}

	return $page;
}


//--------- Debut ajout CI (ne pas prendre en compte dans statistiques le robot et la syndication) ------
// function terminer_public_global() {
function terminer_public_global($fond) {
//--------- Fin ajout CI ---------------------

	// Gestion des statistiques du site public
	if (lire_meta("activer_statistiques") != "non") {
//--------- Debut ajout CI (ne pas prendre en compte dans statistiques le robot et la syndication) ------
//		include_local ("inc-stats.php3");
//		ecrire_stats();
		$cirobot =false;
		if (isset($_SERVER['HTTP_USER_AGENT'])) {	
			if ($_SERVER['HTTP_USER_AGENT'] == 'Robot-indexation@SEN' OR $_SERVER['HTTP_USER_AGENT'] == 'mnogosearch'){
				$cirobot =true;			
			}	
		} 
		if (!$cirobot and !ereg("backend",$fond)) {
			include_local ("inc-stats.php3");
			ecrire_stats();
		}
//--------- Fin ajout CI ---------------------
		
	}
		
//----- debut ajout CI -----
	if (spip_touch("ecrire/data/ci_cron.txt", 900, false)) {
//----- fin ajout CI -------
	
		// Effectuer une tache de fond ?
		cron();
	
//----- debut ajout CI -----
		spip_touch("ecrire/data/ci_cron.txt", 0, true);
	}
//----- fin ajout CI -------
	
}


function inclure_page($fond, $delais_inclus, $contexte_inclus, $cache_incluant='') {

//--------- Debut ajout CI (acces restreints)(ec) -----
	$ci_use_cache=ci_use_cache();
	if (!$ci_use_cache) {
		$use_cache=false;
		$delais_inclus = 0;
		$chemin_cache = '';
		$contexte_inclus['fond'] = $fond;
	} else {
//--------- Fin ajout CI ---------------------
	
		$contexte_inclus['fond'] = $fond;
	
		if ($delais_inclus > 0)
			$chemin_cache = generer_nom_fichier_cache($contexte_inclus, $fond);
		else
			$chemin_cache = '';
	
		// Peut-on utiliser un fichier cache ?
		determiner_cache($delais_inclus, $use_cache, $chemin_cache);

//--------- Debut ajout CI (acces restreints)(ec) -----
	}
//--------- Fin ajout CI ---------------------
	
	
	// Si on a inclus sans fixer le critere de lang, de deux choses l'une :
	// - on est dans la langue du site, et pas besoin d'inclure inc_lang
	// - on n'y est pas, et alors il faut revenir dans la langue par defaut
	if (($lang = $contexte_inclus['lang'])
	|| ($GLOBALS['spip_lang'] != ($lang = lire_meta('langue_site')))) {
		include_ecrire('inc_lang.php3');
		lang_select($lang);
		$lang_select = true; // pour lang_dselect en sortie
	}

	// Une fois le chemin-cache decide, on ajoute la date (et date_redac) 
	// dans le contexte inclus, pour que les criteres {age} etc fonctionnent 
	if (!isset($contexte_inclus['date'])) 
		$contexte_inclus['date'] = date('Y-m-d H:i:s'); 
	if (!isset($contexte_inclus['date_redac'])) 
		$contexte_inclus['date_redac'] = $contexte_inclus['date']; 

	$page = obtenir_page ($contexte_inclus, $chemin_cache, $delais_inclus,
	$use_cache, $fond, true);

	$page['lang_select'] = $lang_select;

	// Retourner le contenu...
	return $page;
}


# Attention, un appel explicite a cette fonction suppose certains include
# (voir l'exemple de spip_inscription et spip_pass)
# $r = complexe (fond, delais, contexte) ; $echo = faut-il faire echo ou return
function inclure_balise_dynamique($texte, $echo=true, $ligne=0) {
	global $contexte_inclus; # provisoire : c'est pour le debuggueur

	if (!is_string($texte))
	  {
		list($fond, $delais, $contexte_inclus) = $texte;

		if ((!$contexte_inclus['lang']) AND
		($GLOBALS['spip_lang'] != lire_meta('langue_site')))
			$contexte_inclus['lang'] = $GLOBALS['spip_lang'];

		// Appeler la page
		$page = inclure_page($fond, $delais, $contexte_inclus);

		if ($page['process_ins'] == 'html') {
				$texte = $page['texte'];
		} else {
				ob_start();
				eval('?' . '>' . $page['texte']);
				$texte = ob_get_contents();
				ob_end_clean();
		}

		if ($page['lang_select'])
			lang_dselect();

	  }

	if ($GLOBALS['var_mode'] == 'debug')
	    $GLOBALS['debug_objets']['resultat'][$ligne] = $texte;

	if ($echo)
			echo $texte;
	else
			return $texte;
}


function message_erreur_404 () {
	if ($GLOBALS['id_article'])
		$erreur = 'public:aucun_article';
	else if ($GLOBALS['id_rubrique'])
		$erreur = 'public:aucune_rubrique';
	else if ($GLOBALS['id_breve'])
		$erreur = 'public:aucune_breve';
	else if ($GLOBALS['id_auteur'])
		$erreur = 'public:aucun_auteur';
	else if ($GLOBALS['id_syndic'])
		$erreur = 'public:aucun_site';
	else
		$erreur = '';

	return _T($erreur);
}

// Renvoie le _GET ou le _POST emis par l'utilisateur
function _request($var) {
	global $_GET, $_POST;
	if (isset($_GET[$var])) return $_GET[$var];
	if (isset($_POST[$var])) return $_POST[$var];
	return NULL;
}

//--------- Debut ajout CI (previsualisation) ---------------------
function ci_url_retour() {
	global $id_article, $id_breve, $id_rubrique, $id_mot, $id_auteur;

	if ($id_article) {
//--------- Debut ajout CI (3clics) -----
//		$urlretour = "ecrire/articles.php3?id_article=".$id_article;
		$urlretour = "_giseh.php?id_article=".$id_article;
//--------- Fin ajout CI ----------------
	}
	else if ($id_breve) {
		$urlretour = "ecrire/breves_voir.php3?id_breve=".$id_breve;
	}
	else if ($id_rubrique) {
		$urlretour = "ecrire/naviguer.php3?coll=".$id_rubrique;
	}
	else if ($id_mot) {
		$urlretour = "ecrire/mots_edit.php3?id_mot=".$id_mot;
	}
	else if ($id_auteur) {
		$urlretour = "ecrire/auteurs_edit.php3?id_auteur=".$id_auteur;
	}
	else {
		$urlretour = "ecrire/";
	}
	return $urlretour;
}

//--------- Fin ajout CI ---------------------

//--------- Debut ajout CI (acces restreints)(ec) -----
function ci_use_cache() {
	
	static $ci_use_cache;

	if (!isset($ci_use_cache)) {
		global $auteur_session;
		$ci_use_cache=true;
		if ($auteur_session) {
			if (cilire_config('ciautorisear')=="oui"){
				// ne pas stocker dans le cache
				$ci_use_cache=false;
			}
		}
	}
	
	return $ci_use_cache;
}
//--------- Fin ajout CI ---------------------

//--------- Debut ajout CI (host auth site public) -----
// restreindre la consultation du site public aux personnes authentifies
// voire uniquement pour certains HOST (cf.fichier de parametrage _config_cas.php3)
function ci_host_auth_site_public($fond) {
	$ci_redirige=false;	// ne redirige pas par defaut							
	$cicassp = cilire_config('cicassp');

	if ($cicassp AND in_array($cicassp,array('tous','uniquement','sauf'))){
	
		if ($fond!="login" AND $fond!="_template/__login") {
			
			$ci_host = "";
			$ci_redirige = true;	// redirige
			if ($cicassp=='tous') {
				// rediriger
			} else {
				// determination du HOST
				if(empty($_SERVER['HTTP_X_FORWARDED_SERVER'])){
					if (empty($_SERVER['SERVER_NAME']))
						$ci_host = $_SERVER['HTTP_HOST'];
					else
						$ci_host = $_SERVER['SERVER_NAME'];
				} else {
					$ci_host = $_SERVER['HTTP_X_FORWARDED_SERVER'];
				}
			
				if ($ci_host) {
					$cicasspurls = cilire_config('cicasspurls');
					if (isset($cicasspurls)) {
						if (is_array($cicasspurls)) {
							// le HOST est-il dans la liste ?
							$ci_dans_liste = false;
							foreach ($cicasspurls as $ciurl) {
								// HOST se terminant par ...
								if (substr($ciurl,0,1)=='.') {
									if ($ciurl==substr($ci_host,-strlen($ciurl))){
										$ci_dans_liste = true;
										break;
									}
								} else {
									if ($ciurl==$ci_host){
										$ci_dans_liste = true;
										break;
									}
								}
							}
							if ($cicassp=='uniquement') {
								// ne pas rediriger si pas dans la liste
								if (!$ci_dans_liste) $ci_redirige = false;
							} elseif ($cicassp=='sauf') {
								// ne pas rediriger si dans la liste
								if ($ci_dans_liste) $ci_redirige = false;								
							}
						}
					}					
				}
			}
		}
	}
	
	return $ci_redirige;
}

function ci_ip_auth_site_public($fond) {
	$ci_redirige=false;	// ne redirige pas par defaut							
	$cicasipsp = cilire_config('cicasipsp');

	if ($cicasipsp AND in_array($cicasipsp,array('tous','uniquement','sauf'))){
	
		if ($fond!="login" AND $fond!="_template/__login") {
			
			$ci_ip_binary = "";
			$ci_redirige = true;	// redirige
			if ($cicasipsp=='tous') {
				// rediriger
			} else {
				// determination de l'IP
				/// exemple de cicasipspordre : array('HTTP_X_FORWARDED_FOR','REMOTE_ADDR')
				$cicasipspordre = cilire_config('cicasipspordre');
				$ci_ip = "";
				if (isset($cicasipspordre)) {
					if (is_array($cicasipspordre)) {
						foreach ($cicasipspordre as $valeur) {
							if (isset($GLOBALS[$valeur])) {
								if ($GLOBALS[$valeur]) {
									$ci_ip = $GLOBALS[$valeur];
									break;
								}
							}
						}
					}
				}

				if ($ci_ip) {
					// IP v6 : ne pas le traiter pour l'instant
					if (substr_count($ip,":") > 0)
				        $ci_ip_binary_string = "";
					// IP v4
					else
				        $ci_ip_binary_string = sprintf("%032b",ip2long($ci_ip));
				}
				
				if ($ci_ip_binary_string) {
					$cicasipspnet = cilire_config('cicasipspnetv4');
					if (isset($cicasipspnet)) {
						if (is_array($cicasipspnet)) {
							// l'IP est-elle dans la liste des rseaux ?
							// exemples : "172.16.0.0"=>"12", "10.0.0.0"=>"8"
							$ci_dans_liste = false;
							foreach ($cicasipspnet as $ci_netaddr=>$ci_netmask) {
							    	$ci_netmask = intval($ci_netmask);
							    	$ci_netaddr_binary_string = "";
									if ($ci_netaddr AND $ci_netmask >0)
								        $ci_netaddr_binary_string = sprintf("%032b",ip2long($ci_netaddr));

									if ($ci_netaddr_binary_string) {										
								        if (strncasecmp($ci_ip_binary_string,$ci_netaddr_binary_string,$ci_netmask) === 0){
											$ci_dans_liste = true;
								        	break;
								        }
									}
							}
							if ($cicasipsp=='uniquement') {
								// ne pas rediriger si pas dans la liste
								if (!$ci_dans_liste) $ci_redirige = false;
							} elseif ($cicasipsp=='sauf') {
								// ne pas rediriger si dans la liste
								if ($ci_dans_liste) $ci_redirige = false;								
							}
						}
					}					
				}
			}
		}
	}
	
	return $ci_redirige;
}

//--------- Fin ajout CI ---------------------

?>