<?php

/***************************************************************************\
 *  SPIP, Systeme de publication pour l'internet                           *
 *                                                                         *
 *  Copyright (c) 2001-2005                                                *
 *  Arnaud Martin, Antoine Pitrou, Philippe Riviere, Emmanuel Saint-James  *
 *                                                                         *
 *  Ce programme est un logiciel libre distribue sous licence GNU/GPL.     *
 *  Pour plus de details voir le fichier COPYING.txt ou l'aide en ligne.   *
\***************************************************************************/


include_once("ecrire/inc_version.php3");
include_ecrire ("inc_session.php3");

//--------- Debut ajout CI (version CAS) -----
$ciauthcas= false;

if (file_exists("ecrire/_config_cas.php3")) {
	include_ecrire("_config_cas.php3");
	// Pour la solution hybride utilisation d'un cookie
	if ($GLOBALS['ciconfig']['cicas']=="oui" OR isset($_COOKIE['equip_sso'])) {
		$ciauthcas= true;
		
		// import phpCAS lib
		include_once('CAS/CAS.php');
		include_once('ecrire/_giseh_inc_cas.php3');
	}
}
//--------- Fin ajout CI -----


// gerer l'auth http
function auth_http($url, $essai_auth_http) {
	global $_SERVER;
	if ($essai_auth_http == 'oui') {
		if (verifier_php_auth())
			redirige_par_entete($url);
		else {
			$url = quote_amp(urlencode($url));
			ask_php_auth(_T('login_connexion_refusee'),
			_T('login_login_pass_incorrect'), _T('login_retour_site'),
			"url=$url", _T('login_nouvelle_tentative'),
			(ereg(_DIR_RESTREINT_ABS, $url)));
			exit;
		}
	}
	// si demande logout auth_http
	else if ($essai_auth_http == 'logout') {
		ask_php_auth(_T('login_deconnexion_ok'),
		_T('login_verifiez_navigateur'), _T('login_retour_public'),
		"redirect="._DIR_RESTREINT_ABS, _T('login_test_navigateur'), true);
		exit;
	}
}

// rejoue le cookie pour renouveler spip_session
if ($change_session == 'oui') {
	if (verifier_session($spip_session)) {
		// Attention : seul celui qui a le bon IP a le droit de rejouer,
		// ainsi un eventuel voleur de cookie ne pourrait pas deconnecter
		// sa victime, mais se ferait deconnecter par elle.
		if ($auteur_session['hash_env'] == hash_env()) {
			$auteur_session['ip_change'] = false;
			$cookie = creer_cookie_session($auteur_session);
			supprimer_session($spip_session);
			spip_setcookie('spip_session', $cookie);
		}
		@header('Content-Type: image/gif');
		@header('Expires: 0');
		@header("Cache-Control: no-store, no-cache, must-revalidate");
		@header('Pragma: no-cache');
		@header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT");
		@readfile(_DIR_IMG_PACK . 'rien.gif');
		exit;
	}
}

if ($url)  $url = urldecode($url);

//--------- Debut ajout CI (version CAS) -----
if ($ciauthcas) {
	if (!$url)  $url = urldecode($var_url);
}	
//--------- Fin ajout CI -----
//----- Debut ajout CI (securite) -----
	$ci_cible_ok=false;
	$ci_cibles_secure=array("./",_DIR_RESTREINT,"index.php3","sommaire.php3","rubrique.php3","article.php3","sujet.php3","forum.php3","recherche.php3","plan.php3","_giseh.php","_article_editer.php3","_article_versions.php3","_chat_index.php3","_upload.php3","_article_reserver_pj.php3");
	while (list(,$ci_cible_secure) = each($ci_cibles_secure)) {
		if (substr($url,0,strlen($ci_cible_secure))==$ci_cible_secure) {
			$ci_cible_ok=true;
			break;
		}	
	}
	if (!$ci_cible_ok) $url = _DIR_RESTREINT;
//----- Fin ajout CI -----

// tentative de connexion en auth_http
if ($essai_auth_http AND !$ignore_auth_http) {
	auth_http(($url ? $url : _DIR_RESTREINT_ABS), $essai_auth_http);
	exit;
}

// cas particulier, logout dans l'espace public
if ($logout_public) {
	$logout = $logout_public;
	if (!$url)
		$url = 'index.php3';
}
// tentative de logout
if ($logout) {
	verifier_visiteur();
	if ($auteur_session['login'] == $logout) {
		spip_query("UPDATE spip_auteurs SET en_ligne = DATE_SUB(NOW(),INTERVAL 6 MINUTE) WHERE id_auteur = ".$auteur_session['id_auteur']);
		if ($spip_session) {
			zap_sessions($auteur_session['id_auteur'], true);
			spip_setcookie('spip_session', $spip_session, time() - 3600 * 24);
		}
		
		if ($_SERVER['PHP_AUTH_USER']
		AND !$ignore_auth_http
		AND verifier_php_auth()) {
			auth_http(($url ? $url : _DIR_RESTREINT_ABS), 'logout');
		}
		unset ($auteur_session);
	}
//--------- Debut ajout CI (version CAS) -----
//	redirige_par_entete($url ? $url : "spip_login.php3");

	if ($ciauthcas) {

		// Pour la solution hybride utilisation d'un cookie
		if(isset($_COOKIE['equip_sso']))
			setcookie('equip_sso', '', time() - 3600);
		
		// Dterminer l'origine de l'appel (intranet, internet, ...)
		// .i2 ou .ader.gouv.fr ou .gouv.fr ou .agri
		$ciurlcas=ci_url_serveur_cas();	
	
		// initialize phpCAS
		$cirep='';
		if (isset($GLOBALS['ciconfig']['cicasrepertoire'])) $cirep=$GLOBALS['ciconfig']['cicasrepertoire'];
		phpCAS::client(CAS_VERSION_2_0,$ciurlcas,443,$cirep);
		
		if (isset($_GET['lang'])) {
			$cilangphpcas=ci_lang_phpcas($_GET['lang']);
		} else {
			$cilangphpcas='french';
		}		
		phpCAS::setLang($cilangphpcas);

		// Dterminer l'url retour
		$ci_url_retour = ci_url_retour($url);
		
		// deconnexion de CAS avec l'url retour	
		if (method_exists('phpCAS','logoutWithUrl')) {
			// Compatibilit avec les versions rcentes de phpCAS
			phpCAS::logoutWithUrl(urlencode($ci_url_retour));
		} else {
			phpCAS::logout(urlencode($ci_url_retour));
		}
		
	} else {
		redirige_par_entete($url ? $url : "spip_login.php3");
	}	
//--------- Fin ajout CI -----

}

// en cas de login sur bonjour=oui, on tente de poser un cookie
// puis de passer a spip_login qui diagnostiquera l'echec de cookie
// le cas echeant.
if ($test_echec_cookie == 'oui') {
	spip_setcookie('spip_session', 'test_echec_cookie');
	redirige_par_entete("spip_login.php3?var_echec_cookie=oui&amp;url="
		. ($url ? $url : _DIR_RESTREINT_ABS));
}

// Tentative de login
unset ($cookie_session);
$redirect = ($url ? $url : _DIR_RESTREINT_ABS);
if ($essai_login == "oui") {

//--------- Debut ajout CI (version CAS) -----
if ($ciauthcas) {
		$ok = false;
			include_ecrire("_giseh_inc_auth_cas.php3");
			$classe_auth = "Auth_cas";
			$auth = new $classe_auth;
			if ($auth->init()) {
				$ok = $auth->ci_verifier_userid($ciuserid);

				// compatibilit avec les anciennes adresses
				if (!$ok) {
					if ($GLOBALS['ciconfig']['cicasuid']!="login") {
						if ($ciuserid) {
							$ci_pos = strpos($ciuserid, '@');
							if ($ci_pos AND $ci_pos > 0) {
								$ci_tableau_email = explode('@',$ciuserid);
								if (strtolower($ci_tableau_email[1])=="developpement-durable.gouv.fr") {
									$ciuserid = $ci_tableau_email[0].'@equipement.gouv.fr';
									$ok = $auth->ci_verifier_userid($ciuserid);
								}
							}
						}
					}
				}
			}
} else {
//--------- Fin ajout CI ---------------------

	// Recuperer le login en champ hidden
	if ($session_login_hidden AND !$session_login)
		$session_login = $session_login_hidden;

	$login = $session_login;
	$pass = $session_password;

//--------- Debut ajout CI (login  rptition) -----
	$ciok = false;
	$ciresult = spip_query ("SELECT cookie_oubli FROM spip_auteurs WHERE login='".addslashes($login)."' AND statut!='5poubelle'");
	if ($row = spip_fetch_array($ciresult)) {
		$cilogold = $row['cookie_oubli'];
		if ($cilogold){
			$cipos = strpos($cilogold,"echec");
			if ($cipos) {
				$cidateechec = intval(substr($cilogold,$cipos+5));
				if (time()>=$cidateechec){
					$ciok =true;
				}
			} else {
				$ciok =true;
			}
		} else {
			$ciok =true;
		}
	} else {
		$ciok =true;
	}
    if($ciok){
//--------- Fin ajout CI ---------------------
		// Essayer differentes methodes d'authentification
		$auths = array('spip');
		include_local(_FILE_CONNECT); // pour savoir si ldap est present 
		if ($ldap_present) $auths[] = 'ldap';
		$ok = false;
		foreach ($auths as $nom_auth) {
			include_ecrire("inc_auth_".$nom_auth.".php3");
			$classe_auth = "Auth_".$nom_auth;
			$auth = new $classe_auth;
			if ($auth->init()) {
				// Essayer les mots de passe md5
				$ok = $auth->verifier_challenge_md5($login, $session_password_md5, $next_session_password_md5);
				// Sinon essayer avec le mot de passe en clair
				if (!$ok && $session_password) $ok = $auth->verifier($login, $session_password);
				if ($ok)  { $auth->lire(); break; }
			}
		}
//--------- Debut ajout CI ---------------------
    } else {
		$ok = false;
    }
//--------- Fin ajout CI ---------------------
//--------- Debut ajout CI (version CAS) -----
}			
//--------- Fin ajout CI ---------------------

	// Si la connexion a reussi
	if ($ok) {
		// Nouveau redacteur ou visiteur inscrit par mail :
		// 'nouveau' -> '1comite' ou  '6forum'
		// Si LDAP : importer l'utilisateur vers la base SPIP
		$auth->activer();

		if ($auth->login AND $auth->statut == '0minirezo') // force le cookie pour les admins
			$cookie_admin = "@".$auth->login;

		// On est connecte : recuperer les donnees auteurs
		// poser le cookie session, puis le cas echeant
		// verifier que le statut correspond au minimum requis,
		$query = "SELECT * FROM spip_auteurs WHERE login='".addslashes($auth->login)."'";
		$result = spip_query($query);
		if ($row_auteur = spip_fetch_array($result)) {
//--------- Debut ajout CI (statut ciredval) ---------------------
			if ($row_auteur['statut'] == 'ciredval') $row_auteur['statut'] ='1comite';
//--------- Fin ajout CI -----------------------------------------
			$cookie_session = creer_cookie_session($row_auteur);
		} else
			$ok = false;

		// Si on se connecte dans l'espace prive, ajouter "bonjour" (inutilise)
		if ($ok AND ereg(_DIR_RESTREINT_ABS, $redirect)) {
		      $redirect .= (strpos($redirect, "?") ? "&" : "?") . 'bonjour=oui';
		}
//--------- Debut ajout CI (version CAS) -----
		if ($ciauthcas) {
		} else {
//--------- Fin ajout CI ---------------------

//--------- Debut ajout CI (login  rptition) ---------------------
		spip_query("UPDATE spip_auteurs SET cookie_oubli='' WHERE login='".addslashes($login)."' ");
//--------- Fin ajout CI ---------------------

//--------- Debut ajout CI (version CAS) -----
		}
//--------- Fin ajout CI ---------------------
		
	}
	if (!$ok) {
//--------- Debut ajout CI (version CAS) -----
		if ($ciauthcas) {
				die ("<H3>"._T('info_acces_interdit')."</H3>");
		} else {
//--------- Fin ajout CI ---------------------
//--------- Debut ajout CI (login  rptition) ---------------------
	        $ciupdate = true;
			$cilognew = "1echec".strval(time());
			$ciresult = spip_query ("SELECT cookie_oubli FROM spip_auteurs WHERE login='".addslashes($login)."' AND statut!='5poubelle'");
			if ($row = spip_fetch_array($ciresult)) {
				$cilogold = $row['cookie_oubli'];
				if ($cilogold){
					$cipos = strpos($cilogold,"echec");
					if ($cipos) {
						$ciintechec = intval(substr($cilogold,0,$cipos)); 
						$cidateechec = intval(substr($cilogold,$cipos+5));
						if ($ciintechec>1){
							if ( ($cidateechec - time()) > 4000 ) $ciupdate = false;   // evite de saturer mysql d'update
							if ( $cidateechec < time()) $cidateechec = time();   // le fait d'attendre permet de rcuprer une seule tentative
	    						$cidatefuture = $cidateechec + 630;
							$cilognew = strval($ciintechec+1)."echec".strval($cidatefuture);
						} else {
							$cilognew = strval($ciintechec+1)."echec".strval(time());
						}
					}
				}
			}
	        if ($ciupdate) spip_query ("UPDATE spip_auteurs SET cookie_oubli='".$cilognew."' WHERE login='".addslashes($login)."' ");

			if (ereg(_DIR_RESTREINT_ABS, $redirect))
				$redirect = "spip_login.php3";
			$redirect .= (strpos($redirect, "?") ? "&" : "?") . "var_login=$login";
			if ($session_password || $session_password_md5)
				$redirect .= '&var_erreur=pass';
			$redirect .= '&url=' . urlencode($url);
			        
//--------- Debut ajout CI (version CAS) -----
		}
//--------- Fin ajout CI ---------------------

	}
 }

// cookie d'admin ?
if ($cookie_admin == "non") {
	if (!$retour)
//--------- Debut ajout CI (var_url) -----
//	  $retour = 'spip_login.php3?var_url='.urlencode($url);
	  $retour = 'spip_login.php3?url='.urlencode($url);
//--------- Fin ajout CI -----

	spip_setcookie('spip_admin', $spip_admin, time() - 3600 * 24);
	$redirect = ereg_replace("([?&])var_login=[^&]*", '\1', urldecode($retour));
	$redirect .= (strpos($redirect, "?") ? "&" : "?") . "var_login=-1";
}
else if ($cookie_admin AND $spip_admin != $cookie_admin) {
	spip_setcookie('spip_admin', $cookie_admin, time() + 3600 * 24 * 14);
}

// cookie de session ?
if ($cookie_session) {
	if ($session_remember == 'oui')
		spip_setcookie('spip_session', $cookie_session, time() + 3600 * 24 * 14);
	else
		spip_setcookie('spip_session', $cookie_session);

	$prefs = ($row_auteur['prefs']) ? unserialize($row_auteur['prefs']) : array();
	$prefs['cnx'] = ($session_remember == 'oui') ? 'perma' : '';
	spip_query ("UPDATE spip_auteurs SET prefs = '".addslashes(serialize($prefs))."' WHERE id_auteur = ".$row_auteur['id_auteur']);

}

// changement de langue espace public
if ($var_lang) {
	include_ecrire('inc_lang.php3');

	if (changer_langue($var_lang)) {
		spip_setcookie('spip_lang', $var_lang, time() + 365 * 24 * 3600);
		$redirect = ereg_replace("[?&]lang=[^&]*", '', $redirect);
		$redirect .= (strpos($redirect, "?") ? "&" : "?") . "lang=$var_lang";
	}
}

// changer de langue espace prive (ou login)
if ($var_lang_ecrire) {
	include_ecrire('inc_lang.php3');
	verifier_visiteur();

	if (changer_langue($var_lang_ecrire)) {
		spip_setcookie('spip_lang_ecrire', $var_lang_ecrire, time() + 365 * 24 * 3600);
		spip_setcookie('spip_lang', $var_lang_ecrire, time() + 365 * 24 * 3600);

		if (_FILE_CONNECT) {
			include_ecrire('inc_admin.php3');
			if (verifier_action_auteur('var_lang_ecrire', $valeur, $id_auteur)) {
				spip_query ("UPDATE spip_auteurs SET lang = '".addslashes($var_lang_ecrire)."' WHERE id_auteur = ".$id_auteur);
				$auteur_session['lang'] = $var_lang_ecrire;
				ajouter_session($auteur_session, $spip_session);	// enregistrer dans le fichier de session
			}
		}

		$redirect = ereg_replace("[?&]lang=[^&]*", '', $redirect);
		$redirect .= (strpos($redirect, "?") ? "&" : "?") . "lang=$var_lang_ecrire";
	}
}

// Redirection
// Sous Apache, les cookies avec une redirection fonctionnent
// Sinon, on fait un refresh HTTP


if (ereg("^Apache", $SERVER_SOFTWARE)) {
	redirige_par_entete($redirect);
}
else {
	spip_header("Refresh: 0; url=" . $redirect);
	echo "<html><head>";
	echo "<meta http-equiv='Refresh' content='0; url=".$redirect."'>";
	echo "</head>\n";
	echo "<body><a href='".$redirect."'>"._T('navigateur_pas_redirige')."</a></body></html>";
}

?>